//+------------------------------------------------------------------+
//|                                              StepMAExpert_v1.mq4 |
//|                           Copyright  2005, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <stdlib.mqh>
#include <Tracert.mqh>

//---- input parameters
extern string     Expert_Name = "---- StepMAExpert_v1 ----";

extern int        MagicNumber=1007;
extern int        Slippage=6;
extern bool       Trace = false;          // Trace Switch

extern string     Main_Parameters = " Trade Volume & Trade Method";
extern double     Lots = 0.1;
extern bool       TrailingStop = false;   // Trailing Stop Switch   
extern bool       SwingTrade = false;     // Swing Trade Switch
extern bool       FirstStop=false;        // First Stop Switch
extern double     ZeroLossLevel=0;        // Zero Loss Level in points

extern string     Calc_Parameters = " StepMA Parameters ";
extern int        Length=10;              // ATR Period	
extern double     Kv=1.0;                 // Sensivity Factor
extern double     StepSize=0;             // Constant Step Size (if need)
extern bool       HighLow=false;          // High/Low Mode Switch (more sensitive)
extern double     Delta=0;                // Breakout Depth in points
extern double     Ks=1.0;                 // StopLoss Factor

extern string     MM_Parameters = " MoneyManagement by L.Williams ";
extern bool       MM=false;               //  Switch
extern double     Risk=0.15;              // Risk Factor
extern double     LossMax=1000;           // Maximum Loss by 1 Lot


int      trend=0,Signal=0,matrend=0;
double   Smin0=0,Smax0=0,Smin1=0,Smax1=0;
double   line0=0,line1=0,bsmin1=0,bsmax1=0;
double   BuyStop=0,SellStop=0,ATRmin=10000,ATRmax=0,bsmax2=0,bsmin2=0;
int      b=0,cnt=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int total,ticket;
//---- 
   
   if ( Trace ) SetTrace();
   if (Bars>b)
   {      
   b=Bars;
   
   if(TrailingStop) FirstStop=true; 
   
   double Lotsi=Lots;     
      
   if (MM > 0) Lotsi=NormalizeDouble(AccountFreeMargin()*Risk/LossMax,1);   
   if (Lotsi<0.1) Lotsi=0.1;
       
   if(StepSize>0) 
   {
   double Step=Kv*StepSize*Point; 
   }
   else
   {
   double ATR0 = iATR(NULL,0,Length,1);
	ATRmax=MathMax(ATR0,ATRmax);
	ATRmin=MathMin(ATR0,ATRmin);
	Step=0.5*Kv*(ATRmax+ATRmin);
	}  
	  	
	  Smin1=Smin0;
	  Smax1=Smax0;
	  
	  if(HighLow)
	  {	  
	  Smax0=Low[1]+2.0*Step;
	  Smin0=High[1]-2.0*Step;
	  }
	  else
	  {	  
	  Smax0=Close[1]+2.0*Step;
	  Smin0=Close[1]-2.0*Step;
	  }
	  	  
	  if(Close[1]>Smax1) matrend=1; 
	  if(Close[1]<Smin1) matrend=-1;
	  
	  line1=line0; 
	  
	  if(matrend>0)
	  {
	  if(Smin0<Smin1) Smin0=Smin1;
	  line0=Smin0+Step;
	  }
	  else
	  {
	  if(Smax0>Smax1) Smax0=Smax1;
	  line0=Smax0-Step;
	  }	  

	  bsmin2=bsmin1;
	  bsmax2=bsmax1;
	  
	  bsmin1=Smin0;
	  bsmax1=Smax0;

// Signal area	  	
// - BUY      
      if 
      (
      Close[1]>iMA(NULL,0,50,0,MODE_EMA,0,1)
      &&
      line0-line1>Delta*Point
      &&
      line1>0
      && 
      trend<=0
      )  Signal= 1;
// - SELL      
      if 
      (
      Close[1]<iMA(NULL,0,50,0,MODE_EMA,0,1)
      &&
      line1-line0>Delta*Point
      &&
      line1>0
      && 
      trend>=0
      )  Signal= -1;
   
// Orders Close area  :              
// - BUY Orders
     if (TrailingStop == 0)
     {    
         if ( Signal<0 )
         {
            total=OrdersTotal();
	         for (cnt=0;cnt<total;cnt++)
               {
               OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
               if (OrderType()==OP_BUY)
                  {
			         OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
			         }
               }
         }
// - SELL Orders          
          
	       if ( Signal>0 )
	       {
            total=OrdersTotal();
		      for (cnt=0;cnt<total;cnt++)
               {
               OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
			      if (OrderType()==OP_SELL)
			         {
   			      OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White);
                  }
               }
           }    
      }
      else
// Orders Modify Area      
      {
       if ( bsmin1>BuyStop && bsmin1>bsmin2 )
         {
            total=OrdersTotal();
	         for (cnt=0;cnt<total;cnt++)
               {
               OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
               if (OrderType()==OP_BUY)
                  {
			         OrderModify(OrderTicket(),0,bsmin1,0,0,LightBlue);
			         return(0);
                  }
               }
         }
// - SELL Orders          
          
	       if ( bsmax1<SellStop && bsmax1<bsmax2 )
	       {
            total=OrdersTotal();
		      for (cnt=0;cnt<total;cnt++)
               {
               OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
			      if (OrderType()==OP_SELL)
			         {
   			      OrderModify(OrderTicket(),0,bsmax1,0,0,Orange);	    
                  return(0);
                  }
               }
           }    
      }
//-----------------------------
           if (ZeroLossLevel > 0 )
           {
            total=OrdersTotal();
	         for (cnt=0;cnt<total;cnt++)
               {
               OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
               if (OrderType()==OP_BUY)
                  {
			         if (Bid-OrderOpenPrice() > ZeroLossLevel*Point) 
			            {
			            bsmin1=OrderOpenPrice()+Point;
			            OrderModify(OrderTicket(),0,bsmin1,0,0,LightBlue);
			            }
			         return(0);
			                      
                 }
                  else
                 {
                  if (OrderOpenPrice()-Ask > ZeroLossLevel*Point) 
			            {
			            bsmax1=OrderOpenPrice()-Point;
			            OrderModify(OrderTicket(),0,bsmax1,0,0,Orange);
			            }
			         return(0);
			                      
                  }
               }
           }                 
// Orders open area :
// - SELL Orders  		     
		     if ( trend>=0 && Signal<0 ) 
           {  
            if (FirstStop) SellStop=line0+Ks*Step; else SellStop=0;
            if (OrdersTotal()<1)
               {
		         ticket=OrderSend(Symbol(),OP_SELL,Lotsi,Bid,Slippage,SellStop,0,"sell",MagicNumber,0,Red);
               if(SwingTrade) trend=-1; else trend=0;
               if(ticket<0)
                  {
                  Print("OrderSend failed with error #",GetLastError());
                  return(0);
                  }
		         return(0);
		         }
           }
// - BUY Orders         
	      if (trend <=0 &&  Signal>0)
	      {
            if (FirstStop) BuyStop=line0-Ks*Step; else BuyStop=0;
                       
		      if (OrdersTotal()<1)
                  {
		    	      ticket=OrderSend(Symbol(),OP_BUY,Lotsi,Ask,Slippage,BuyStop,0,"buy",MagicNumber,0,Blue);
                  if(SwingTrade) trend=1; else trend=0;
                  if(ticket<0)
                     {
                     Print("OrderSend failed with error #",GetLastError());
                     return(0);
                     }
			         return(0);
                  }
            }
      }//if (Bars>b)
//----                          
 

//----
   return(0);
  }
//+------------------------------------------------------------------+